(*
$Id: tedos.pas 1.7 2002/03/19 08:26:33 tony Exp tony $
$Log: tedos.pas $
Revision 1.7  2002/03/19 08:26:33  tony
Reeformatted source code

Revision 1.6  2001/08/28 16:41:16  tony
Added string constants for help hints

Revision 1.5  2001/08/24 07:23:38  tony
Fixed command constants, cleaned up source

Revision 1.4  2001/08/24 06:55:50  tony
Fixed backup flag problem

Revision 1.3  2001/08/23 07:11:19  tony
Fixed usage code, hid /I option

Revision 1.3  2001/08/23 07:03:48  tony
Updated commandline options, and hid the /I option.

Revision 1.2  2001/08/17 01:43:31  tony
Fixed /I hidden option so that it returned the proper information

Revision 1.2  2001/08/16 21:45:23  tony
fixed problem with /I parameter not returning proper information

Revision 1.1  2001/08/16 21:36:38  tony
Initial revision


                Tony's Full Screen Editor
                Version 1.0
                Copyright (C) AGE Software

                Purpose: Full Screen Editor for DOS
                FILENAME: TEDOS.PAS

                Contains procedures and functions for processing the
                command line and displaying usage information

*)

unit TEDOS;

interface

uses TeConst;

function GetProgName (S : String) : string;

{
   GetProgName takes a string argument S and uses FSplit to split
   the filename stored in S into directory, name, and extension.
   Since I only want the extension, I discard the other information.
}

procedure ParseCmdLine;

{
  Processes command line for the editor
}

implementation


uses Drivers, Strings, Editors, Dos;

{$IFDEF MSDOS}
const switchar = '/';
{$ELSE}
const switchar = '-';
{$ENDIF}
  TEDOSRCSID : string = '$Id: tedos.pas 1.7 2002/03/19 08:26:33 tony Exp tony $';
  TEDOSRCSRev : string ='$Revision: 1.7 $';

var Progname : string;

procedure Usage;

var S : String;

begin
  FormatStr(S, ' - Version %d.%d ', VERSION);
  PrintStr(progname+S);
    printStr(Copy(RCSRev,2,(Length(RCSRev) - 2)));
  PrintStr(CRLF+'Text Editor'+CRLF+CRLF);
  printstr(progname+ ' ['+switchar);
  printstr('B] ['+switchar);
  printstr('HI] [file(s)]'+CRLF+CRLF);
  printstr('   '+switchar+'B     - turns off the auto backup feature'+CRLF);
  printstr('   '+switchar+'?     - Displays this help screen'+CRLF);
  printstr('   '+switchar+'HI    - Displays the maximum number of lines possible for your hardware.'+CRLF);
  printstr('  [file]  - specifies the initial file(s) to load.'+CRLF);
  printstr('            multiple filespecs can be given.'+CRLF);
  printstr(CRLF+COPYRIGHT+CRLF);
end;

function GetProgName(S : String) : string;

var D : DirStr;
    N : NameStr;
    E : ExtStr;

begin
  FSplit(S, D, N, E);
  GetProgName := N;
end;

procedure ParseCmdLine;

var
 I : Byte;
 P : PChar;
 S : String;

begin
  if Lo(DosVersion) >= 3 then progname := GetProgName(paramstr(0))
  else
    begin
      progname := FSearch('TE.EXE', GetEnv('PATH'));
      if progname = '' then printstr('TE.EXE could not be found.'+CRLF);
    end;

  {
    progname is a global variable defined in TECONST.PAS
  }
  if paramcount > 0 then
    for i := 1 to paramcount do begin
      StrPCopy(P, paramstr(i));
      StrUpper(P);
      if char(P^) in ['/','-'] then begin
        inc(P);
        case char( P^) of
          'B' : EditorFlags := EditorFlags xor efBackupFiles;
          '?' :
            begin
              Usage;
              halt;
            end;
          'H' : begin
                  inc(P);
                  if char(P^) = 'I' then
                    ScreenMode := ScreenMode xor smFont8x8
                  else
                    begin
                      Usage;
                      halt;
                    end;
                  dec(P);
                end;
          'I' :
           begin
             FormatStr(S, ' - Version %d.%d ', VERSION);
             PrintStr(progname+S);
              PrintStr(Copy(RCSRev,2,(Length(RCSRev) - 2))+CRLF+CRLF);
             halt;
           end;
          else;
        end;
      end;
    end;
end;

begin
{
  Make sure the resource file is available
}
  if length(FSearch('TE.RES',GetEnv('PATH'))) = 0 then
    begin
      PrintStr('Unable to locate resource file.'+CRLF);
      PrintStr('Aborting'+CRLF);
      halt(50);
    end;

end.
